<template>
  <form
    ref="form"
    @submit.prevent="onSaveBeneficiary"
  >
    <AtomMultiSelect
      name="referents"
      label="Agent(s) référent(s)"
      :options="referentOptions"
      :model-value="initialReferentIds"
      required
      dropdown
      :readonly="!canSetReferents"
      :disabled-options="disabledReferentOptions"
    />

    <AtomCheckbox
      class="fr-mb-4w"
      label="Mandat Aidant Connect"
      name="aidant_connect_authorisation"
      :model-value="beneficiary && beneficiary.aidant_connect_authorisation"
    />

    <div
      ref="accordion"
      class="fr-accordions-group"
    >
      <BeneficiaryFormGeneralInformation :beneficiary="beneficiary" />
      <BeneficiaryFormRelatives
        v-if="canSetRelatives"
        :beneficiary="beneficiary"
        :relatives="formHouseholdRelatives"
        household
        @add-relative="() => onAddRelative(true)"
        @remove-relative="$event => onRemoveRelative($event, true)"
        @change-family-situation="familySituation = $event"
        @change-major-children-nb="majorChildrenNb = $event"
      />
      <BeneficiaryFormRelatives
        v-if="canSetRelatives"
        :relatives="formRelatives"
        @add-relative="onAddRelative"
        @remove-relative="onRemoveRelative"
      />
      <BeneficiaryFormHealth
        v-if="canSetHealth"
        :beneficiary="beneficiary"
      />
      <BeneficiaryFormOccupationIncome
        v-if="canSetOccupationIncome"
        :beneficiary="beneficiary"
        :family-situation="familySituation"
        :major-children-nb="majorChildrenNb"
      />
      <BeneficiaryFormExternalOrganisations
        v-if="canSetExternalOrganisations"
        :beneficiary="beneficiary"
      />
    </div>

    <AtomTextarea
      v-if="canSetGeneralInformation"
      class="fr-col-12"
      name="additional_information"
      label="Informations complémentaires"
      hint
      :value="beneficiary?.additional_information || ''"
    >
      <template #hint>
        {{ SENSITIVE_DATA_HINT }}
      </template>
    </AtomTextarea>

    <button
      class="fr-btn fr-btn--lg submit-btn"
      type="submit"
      :submitting="isSubmitting"
      :disabled="isSubmitting"
      @click="onCheckValidationBeforeSubmit"
    >
      Enregistrer
    </button>
  </form>
</template>

<script setup>
  import { agentToAgentOption } from '~/utils'
  import { beneficiaryFromForm } from '~/utils/beneficiaryFromForm'
  import { SENSITIVE_DATA_HINT } from '~/utils/constants'
  import {
    CREATED_HOUSEHOLD_RELATIVE_ID_PREFIX,
    CREATED_RELATIVE_ID_PREFIX
  } from '~/utils/constants/relative'
  import { getRandomId } from '~/utils/random'
  import { usePermissionsStore } from '~/store/permissions'

  const permissionsStore = usePermissionsStore()

  const props = defineProps({
    beneficiary: { type: Object, default: null },
    agents: { type: Array, required: true },
    isSubmitting: { type: Boolean, required: true },
    householdRelatives: { type: Array, default: () => [] },
    relatives: { type: Array, default: () => [] }
  })

  const emit = defineEmits(['saveBeneficiary'])

  const formHouseholdRelatives = ref(props.householdRelatives)
  const formRelatives = ref(props.relatives)
  const familySituation = ref('')
  const majorChildrenNb = ref(0)
  const form = ref(null)

  const referentOptions = computed(
    () => new Map(props.agents.map(agentToAgentOption))
  )

  const disabledReferentOptions = computed(() =>
    props.agents.reduce((disabledOptions, agent) => {
      const disabledAgent = agent.status !== 'active'
      const agentIsBeneficiaryReferent = (
        props.beneficiary?.referents || []
      ).some(({ referent }) => referent.id === agent.id)
      return disabledAgent && !agentIsBeneficiaryReferent
        ? [...disabledOptions, agent.id]
        : disabledOptions
    }, [])
  )

  const initialReferentIds = computed(() => {
    if (!isEditing.value) return []
    return props.beneficiary.referents.map(({ referent }) => referent.id)
  })

  const isEditing = computed(() => props.beneficiary)

  const canSetReferents = computed(() =>
    permissionsStore.canSetReferents(props.beneficiary)
  )

  const canSetRelatives = computed(() => permissionsStore.canSetRelatives)

  const canSetHealth = computed(() => permissionsStore.canSetHealth)

  const canSetOccupationIncome = computed(
    () => permissionsStore.canSetOccupationIncome
  )

  const canSetExternalOrganisations = computed(
    () => permissionsStore.canSetExternalOrganisations
  )

  const canSetGeneralInformation = computed(
    () => permissionsStore.canSetGeneralInformation
  )

  onMounted(() => {
    if (isEditing.value) {
      familySituation.value = props.beneficiary.family_situation || ''
      majorChildrenNb.value = props.beneficiary.major_children || 0
    }
  })

  function onCheckValidationBeforeSubmit() {
    // Open the accordion containing the first invalid field
    const firstInvalidField = form.value?.querySelector(
      'input:invalid, select:invalid'
    )
    if (!firstInvalidField) return
    const closestAccordionCollapse = firstInvalidField.closest('.fr-collapse')
    if (!closestAccordionCollapse) return
    dsfr(closestAccordionCollapse).collapse.disclose()
  }

  function onSaveBeneficiary({ target }) {
    const beneficiary = beneficiaryFromForm(
      target,
      props.beneficiary,
      formHouseholdRelatives.value,
      formRelatives.value,
      permissionsStore.canSetRelatives
    )
    emit('saveBeneficiary', beneficiary)
  }

  function onAddRelative(household) {
    if (household) {
      formHouseholdRelatives.value.push({
        id: getRandomId(CREATED_HOUSEHOLD_RELATIVE_ID_PREFIX)
      })
    } else {
      formRelatives.value.push({ id: getRandomId(CREATED_RELATIVE_ID_PREFIX) })
    }
  }

  function onRemoveRelative(relativeId, household) {
    if (household) {
      formHouseholdRelatives.value = formHouseholdRelatives.value.filter(
        ({ id }) => id !== relativeId
      )
    } else {
      formRelatives.value = formRelatives.value.filter(
        ({ id }) => id !== relativeId
      )
    }
  }
</script>

<style lang="scss" scoped>
  .fr-accordions-group {
    margin-bottom: 1.5rem;
  }
</style>
